﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace OutlookSample
{
  public class Folder
  {
    #region Declarations
    private Mails _Mails;
    private Folder _Parent;
    #endregion

    #region Properties
    /// <summary>
    /// 
    /// </summary>
    private OutlookClient Client { get; set; }
    /// <summary>
    /// 
    /// </summary>
    public string DisplayName { get; set; }
    /// <summary>
    /// 
    /// </summary>
    public Mails Mails
    {
      get
      {
        if (_Mails != null) return _Mails;
        _Mails = Client.CreateMailsFromFolder(GetEntryID(), GetStoreID());
        return _Mails;
      }
    }
    /// <summary>
    /// 
    /// </summary>
    public string ID { get; set; }
    /// <summary>
    /// 
    /// </summary>
    public string Name { get; set; }
    /// <summary>
    /// 
    /// </summary>
    public Folder Parent
    {
      get
      {
        if (_Parent != null) return _Parent;
        _Parent = Client.CreateFolderByID(GetEntryID(), GetStoreID(), true);
        return _Parent;
      }
    }
    #endregion

    #region Constructors
    /// <summary>
    /// 
    /// </summary>
    /// <param name="client"></param>
    public Folder(OutlookClient client)
    {
      Client = client;
    }
    #endregion

    #region Methods
    /// <summary>
    /// 
    /// </summary>
    /// <param name="from"></param>
    /// <param name="to"></param>
    /// <returns></returns>
    public Mails GetMailsByFilter(DateTime from, DateTime to)
    {
      // NOTE: Outlook ReceivedTime == createTime at this moment 
      // (important: if user must be click send to send mails realy)
      var query = string.Format("[SentOn] >= '{0}' AND [SentOn] <= '{1}'",
                                   from.ToString("dd/MM/yyyy hh:mm tt", OutlookClient.CiUs),
                                   to.ToString("dd/MM/yyyy hh:mm tt", OutlookClient.CiUs));

      return Client.CreateMailsFromFolder(GetEntryID(), GetStoreID(), query);
    }
    /// <summary>
    /// 
    /// </summary>
    /// <returns></returns>
    private string GetEntryID()
    {
      string entryID = null;

      if (!string.IsNullOrEmpty(ID) && ID.Contains("*"))
      {
        var ids = ID.Split('*');

        if (ids.Length == 2)
        {
          entryID = ids[0];
        }
      }

      return entryID;
    }
    /// <summary>
    /// 
    /// </summary>
    /// <returns></returns>
    private string GetStoreID()
    {
      string storeId = null;

      if (!string.IsNullOrEmpty(ID) && ID.Contains("*"))
      {
        var ids = ID.Split('*');

        if (ids.Length == 2)
        {
          storeId = ids[1];
        }
      }

      return storeId;
    }

    #endregion
  }
}
