﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Windows.Forms;

namespace OutlookSample
{
  public partial class Main : Form
  {
    private OutlookClient _Client = new OutlookClient();
    private Folder _FolderInbox;

    public Main()
    {
      /* 
       
      With this example, I just want to simulate what happens in a short time when the security manager is invoked.
      In my real program, this error occurs when a user calls in quick succession this function.

      The error occurs sometimes when the OutlookClient.CreateMailsFromFolder(...) is called.
       
       In this example, the error appears if the first time OutlookClient.BeginSecurity  is called.
       * 
       */

      InitializeComponent();

      _FolderInbox = _Client.CreateFolderByType(Outlook.OlDefaultFolders.olFolderInbox);


      //--------------- !!! first error!!!
      var mailCount = _FolderInbox.Mails.Count; // start buffering

      /* 
       
      Throw the following error:
        
      System.Runtime.InteropServices.COMException (0x80004005): Error HRESULT E_FAIL has been returned from a call to a COM component.
      at AddinExpress.Outlook.IOutlookSecurityManager2.Check(Int32 apiType)
      at AddinExpress.Outlook.SecurityManager.set_DisableOOMWarnings(Boolean value) 
       
      */

      //--------------- 

      timer1.Start(); // timer with 1000 ms 
      timer2.Start(); // timer with 1100 ms
    }

    private void timer_Tick(object sender, EventArgs e)
    {
      listBox1.Items.Clear();
      foreach (var mail in _FolderInbox.Mails)
      {
        listBox1.Items.Add(mail);
      }
    }

    private void timer2_Tick(object sender, EventArgs e)
    {
      listBox2.Items.Clear();
      foreach (var mail in _FolderInbox.Mails)
      {
        listBox2.Items.Add(mail);
      }
    }
  }
}
